#ifndef __PROOF_HPP
#define __PROOF_HPP

#include <openssl/evp.h>
#include <openssl/sha.h>
#include <string>
#include <vector>
#include <sstream>
#include <iomanip>

#include "Scalar.hpp"
#include "Curvepoint.hpp"
#include "Bipoint.hpp"

class Proof {
    public:
        Proof();
        Proof(std::string hbc);
    
        // HBC security
        std::string hbc;

        // Malicious security
        std::vector<Curvepoint> curvepointUniversals;
        std::vector<CurveBipoint> curveBipointUniversals;
        std::vector<TwistBipoint> twistBipointUniversals;

        std::vector<Scalar> challengeParts;
        std::vector<Scalar> responseParts;
};

Scalar oracle(const std::string& input);

#endif

